package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.TestBbbCopy;
import com.izouma.awesomeadmin.service.TestBbbCopyService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/testBbbCopy")
public class TestBbbCopyController {

    @Autowired
    private TestBbbCopyService testBbbCopyService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(TestBbbCopy record) {
        List<TestBbbCopy> pp = testBbbCopyService.getTestBbbCopyList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getTestBbbCopy", method = RequestMethod.GET)
    @ResponseBody
    public Result getTestBbbCopy(@RequestParam(required = false, value = "id") String id) {
        TestBbbCopy data = testBbbCopyService.getTestBbbCopyById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(TestBbbCopy record) {
        TestBbbCopy data = testBbbCopyService.getTestBbbCopy(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, TestBbbCopy record) {
        Map<String, Object> result = new HashMap<>();

        List<TestBbbCopy> pp =testBbbCopyService.getTestBbbCopyByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(TestBbbCopy record) {
        boolean num = testBbbCopyService.createTestBbbCopy(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateTestBbbCopy(TestBbbCopy record) {
        boolean num = testBbbCopyService.updateTestBbbCopy(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteTestBbbCopy(@RequestParam(required = true, value = "id") String id) {

        boolean num = testBbbCopyService.deleteTestBbbCopy(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, TestBbbCopy record) throws Exception {

    List<TestBbbCopy> testBbbCopys = testBbbCopyService.getTestBbbCopyList(record);


        String sheetName = "test_bbb_copy";
        String titleName = "test_bbb_copy数据表";
        String fileName = "test_bbb_copy表";
        int columnNumber = 4;
        int[] columnWidth = { 20,  20,  20,  20 };
        String[] columnName = {  "id" ,   "删除标识" ,   "名称1" ,   "名称2"  };
        String[][] dataList = new String[testBbbCopys.size()][4];

        for (int i = 0; i < testBbbCopys.size(); i++) {

                        dataList[i][0] = String.valueOf(testBbbCopys.get(i).getId());
                        dataList[i][1] = String.valueOf(testBbbCopys.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(testBbbCopys.get(i).getNameAaa());
                        dataList[i][3] = String.valueOf(testBbbCopys.get(i).getNameBbb());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

